diff --git a/arch/arm/mach-uniphier/arm32/cache-uniphier.c b/arch/arm/mach-uniphier/arm32/cache-uniphier.c
index b6e4abbad0..cde2a8124f 100644
--- a/arch/arm/mach-uniphier/arm32/cache-uniphier.c
+++ b/arch/arm/mach-uniphier/arm32/cache-uniphier.c
@@ -5,7 +5,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <cpu_func.h>
 #include <linux/io.h>
 #include <linux/kernel.h>
diff --git a/arch/arm/mach-uniphier/arm32/psci.c b/arch/arm/mach-uniphier/arm32/psci.c
index b54dc3979d..a4d260aece 100644
--- a/arch/arm/mach-uniphier/arm32/psci.c
+++ b/arch/arm/mach-uniphier/arm32/psci.c
@@ -4,7 +4,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <cpu_func.h>
 #include <linux/bitops.h>
 #include <linux/delay.h>
diff --git a/arch/arm/mach-uniphier/arm32/timer.c b/arch/arm/mach-uniphier/arm32/timer.c
index b3c907b508..a40bdf1705 100644
--- a/arch/arm/mach-uniphier/arm32/timer.c
+++ b/arch/arm/mach-uniphier/arm32/timer.c
@@ -3,7 +3,7 @@
  * Copyright (C) 2012-2015 Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
+#include <config.h>
 #include <init.h>
 #include <linux/io.h>
 
diff --git a/arch/arm/mach-uniphier/arm64/mem_map.c b/arch/arm/mach-uniphier/arm64/mem_map.c
index 7653bd2d3c..a8bd4eee89 100644
--- a/arch/arm/mach-uniphier/arm64/mem_map.c
+++ b/arch/arm/mach-uniphier/arm64/mem_map.c
@@ -3,7 +3,6 @@
  * Copyright (C) 2016 Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <linux/types.h>
 #include <asm/armv8/mmu.h>
 
diff --git a/arch/arm/mach-uniphier/base-address.c b/arch/arm/mach-uniphier/base-address.c
index 5ee742e363..d7456f8df6 100644
--- a/arch/arm/mach-uniphier/base-address.c
+++ b/arch/arm/mach-uniphier/base-address.c
@@ -3,9 +3,9 @@
 // Copyright (C) 2019 Socionext Inc.
 //   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
 
-#include <common.h>
 #include <dm/of.h>
 #include <fdt_support.h>
+#include <linux/errno.h>
 #include <linux/io.h>
 #include <linux/libfdt.h>
 #include <linux/sizes.h>
diff --git a/arch/arm/mach-uniphier/board_late_init.c b/arch/arm/mach-uniphier/board_late_init.c
index 378aad0c9c..b800e8b8c6 100644
--- a/arch/arm/mach-uniphier/board_late_init.c
+++ b/arch/arm/mach-uniphier/board_late_init.c
@@ -5,7 +5,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <env.h>
 #include <init.h>
 #include <spl.h>
diff --git a/arch/arm/mach-uniphier/boards.c b/arch/arm/mach-uniphier/boards.c
index d9a8d2f28a..3e2ec9b26a 100644
--- a/arch/arm/mach-uniphier/boards.c
+++ b/arch/arm/mach-uniphier/boards.c
@@ -4,9 +4,9 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <linux/libfdt.h>
 #include <linux/kernel.h>
+#include <asm/global_data.h>
 
 #include "init.h"
 
diff --git a/arch/arm/mach-uniphier/boot-device/boot-device-ld11.c b/arch/arm/mach-uniphier/boot-device/boot-device-ld11.c
index 11e70a926f..4689ed79fd 100644
--- a/arch/arm/mach-uniphier/boot-device/boot-device-ld11.c
+++ b/arch/arm/mach-uniphier/boot-device/boot-device-ld11.c
@@ -4,7 +4,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <spl.h>
 #include <linux/io.h>
 #include <linux/kernel.h>
diff --git a/arch/arm/mach-uniphier/boot-device/boot-device-ld4.c b/arch/arm/mach-uniphier/boot-device/boot-device-ld4.c
index 02b239475f..c6aef18c19 100644
--- a/arch/arm/mach-uniphier/boot-device/boot-device-ld4.c
+++ b/arch/arm/mach-uniphier/boot-device/boot-device-ld4.c
@@ -5,7 +5,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <spl.h>
 #include <linux/io.h>
 #include <linux/kernel.h>
diff --git a/arch/arm/mach-uniphier/boot-device/boot-device-pro5.c b/arch/arm/mach-uniphier/boot-device/boot-device-pro5.c
index 55452484d9..efd07a3296 100644
--- a/arch/arm/mach-uniphier/boot-device/boot-device-pro5.c
+++ b/arch/arm/mach-uniphier/boot-device/boot-device-pro5.c
@@ -4,7 +4,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <spl.h>
 #include <linux/io.h>
 #include <linux/kernel.h>
diff --git a/arch/arm/mach-uniphier/boot-device/boot-device-pxs2.c b/arch/arm/mach-uniphier/boot-device/boot-device-pxs2.c
index 49c5da1469..677470cdc6 100644
--- a/arch/arm/mach-uniphier/boot-device/boot-device-pxs2.c
+++ b/arch/arm/mach-uniphier/boot-device/boot-device-pxs2.c
@@ -4,7 +4,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <spl.h>
 #include <linux/io.h>
 #include <linux/kernel.h>
diff --git a/arch/arm/mach-uniphier/boot-device/boot-device-pxs3.c b/arch/arm/mach-uniphier/boot-device/boot-device-pxs3.c
index 4aee50f5d3..6888099312 100644
--- a/arch/arm/mach-uniphier/boot-device/boot-device-pxs3.c
+++ b/arch/arm/mach-uniphier/boot-device/boot-device-pxs3.c
@@ -4,7 +4,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <spl.h>
 #include <linux/bitops.h>
 #include <linux/io.h>
diff --git a/arch/arm/mach-uniphier/boot-device/boot-device.c b/arch/arm/mach-uniphier/boot-device/boot-device.c
index 2fb625535b..69a35f5fb8 100644
--- a/arch/arm/mach-uniphier/boot-device/boot-device.c
+++ b/arch/arm/mach-uniphier/boot-device/boot-device.c
@@ -4,12 +4,12 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <command.h>
 #include <spl.h>
 #include <stdio.h>
 #include <linux/bitops.h>
 #include <linux/bug.h>
+#include <linux/errno.h>
 #include <linux/io.h>
 #include <linux/log2.h>
 
diff --git a/arch/arm/mach-uniphier/clk/clk-dram-ld4.c b/arch/arm/mach-uniphier/clk/clk-dram-ld4.c
index c796d364bb..3b721eaf23 100644
--- a/arch/arm/mach-uniphier/clk/clk-dram-ld4.c
+++ b/arch/arm/mach-uniphier/clk/clk-dram-ld4.c
@@ -4,7 +4,6 @@
  * Copyright (C) 2015-2017 Socionext Inc.
  */
 
-#include <common.h>
 #include <spl.h>
 #include <linux/io.h>
 
diff --git a/arch/arm/mach-uniphier/clk/clk-dram-pxs2.c b/arch/arm/mach-uniphier/clk/clk-dram-pxs2.c
index b78bd01672..75d3e70d6a 100644
--- a/arch/arm/mach-uniphier/clk/clk-dram-pxs2.c
+++ b/arch/arm/mach-uniphier/clk/clk-dram-pxs2.c
@@ -3,7 +3,6 @@
  * Copyright (C) 2016-2017 Socionext Inc.
  */
 
-#include <common.h>
 #include <spl.h>
 #include <linux/io.h>
 
diff --git a/arch/arm/mach-uniphier/clk/clk-early-ld4.c b/arch/arm/mach-uniphier/clk/clk-early-ld4.c
index 0f9ce65097..25b72d8926 100644
--- a/arch/arm/mach-uniphier/clk/clk-early-ld4.c
+++ b/arch/arm/mach-uniphier/clk/clk-early-ld4.c
@@ -4,7 +4,6 @@
  * Copyright (C) 2015-2017 Socionext Inc.
  */
 
-#include <common.h>
 #include <spl.h>
 #include <linux/io.h>
 
diff --git a/arch/arm/mach-uniphier/clk/clk-ld11.c b/arch/arm/mach-uniphier/clk/clk-ld11.c
index 94b9d904dc..d241a65382 100644
--- a/arch/arm/mach-uniphier/clk/clk-ld11.c
+++ b/arch/arm/mach-uniphier/clk/clk-ld11.c
@@ -3,7 +3,6 @@
  * Copyright (C) 2016 Socionext Inc.
  */
 
-#include <common.h>
 #include <spl.h>
 #include <linux/bitops.h>
 #include <linux/delay.h>
diff --git a/arch/arm/mach-uniphier/clk/dpll-ld4.c b/arch/arm/mach-uniphier/clk/dpll-ld4.c
index fd77aa7e11..3ccaf02242 100644
--- a/arch/arm/mach-uniphier/clk/dpll-ld4.c
+++ b/arch/arm/mach-uniphier/clk/dpll-ld4.c
@@ -4,7 +4,6 @@
  * Copyright (C) 2015-2016 Socionext Inc.
  */
 
-#include <common.h>
 #include <linux/delay.h>
 #include <linux/errno.h>
 #include <linux/io.h>
diff --git a/arch/arm/mach-uniphier/clk/dpll-pro4.c b/arch/arm/mach-uniphier/clk/dpll-pro4.c
index c86881dabd..44006ae6dc 100644
--- a/arch/arm/mach-uniphier/clk/dpll-pro4.c
+++ b/arch/arm/mach-uniphier/clk/dpll-pro4.c
@@ -4,7 +4,6 @@
  * Copyright (C) 2015-2016 Socionext Inc.
  */
 
-#include <common.h>
 #include <linux/delay.h>
 #include <linux/errno.h>
 #include <linux/io.h>
diff --git a/arch/arm/mach-uniphier/debug-uart/debug-uart.c b/arch/arm/mach-uniphier/debug-uart/debug-uart.c
index a70ce59acc..d116d46812 100644
--- a/arch/arm/mach-uniphier/debug-uart/debug-uart.c
+++ b/arch/arm/mach-uniphier/debug-uart/debug-uart.c
@@ -3,7 +3,6 @@
  * Copyright (C) 2016 Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <debug_uart.h>
 #include <linux/io.h>
 #include <linux/serial_reg.h>
diff --git a/arch/arm/mach-uniphier/dram/cmd_ddrmphy.c b/arch/arm/mach-uniphier/dram/cmd_ddrmphy.c
index a6c0735198..629f8b90c9 100644
--- a/arch/arm/mach-uniphier/dram/cmd_ddrmphy.c
+++ b/arch/arm/mach-uniphier/dram/cmd_ddrmphy.c
@@ -4,7 +4,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <command.h>
 #include <stdio.h>
 #include <linux/io.h>
diff --git a/arch/arm/mach-uniphier/dram/cmd_ddrphy.c b/arch/arm/mach-uniphier/dram/cmd_ddrphy.c
index 476c5b3582..ca519d1c7e 100644
--- a/arch/arm/mach-uniphier/dram/cmd_ddrphy.c
+++ b/arch/arm/mach-uniphier/dram/cmd_ddrphy.c
@@ -5,7 +5,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <command.h>
 #include <stdio.h>
 #include <linux/io.h>
diff --git a/arch/arm/mach-uniphier/dram/umc-ld4.c b/arch/arm/mach-uniphier/dram/umc-ld4.c
index 2d1f3e3dc0..96acca2562 100644
--- a/arch/arm/mach-uniphier/dram/umc-ld4.c
+++ b/arch/arm/mach-uniphier/dram/umc-ld4.c
@@ -5,7 +5,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <linux/errno.h>
 #include <linux/io.h>
 #include <linux/sizes.h>
diff --git a/arch/arm/mach-uniphier/dram/umc-pro4.c b/arch/arm/mach-uniphier/dram/umc-pro4.c
index 012e5f869b..cde39b499b 100644
--- a/arch/arm/mach-uniphier/dram/umc-pro4.c
+++ b/arch/arm/mach-uniphier/dram/umc-pro4.c
@@ -5,7 +5,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <linux/errno.h>
 #include <linux/io.h>
 #include <linux/sizes.h>
diff --git a/arch/arm/mach-uniphier/dram/umc-sld8.c b/arch/arm/mach-uniphier/dram/umc-sld8.c
index b55b04415c..a11586952d 100644
--- a/arch/arm/mach-uniphier/dram/umc-sld8.c
+++ b/arch/arm/mach-uniphier/dram/umc-sld8.c
@@ -5,7 +5,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <linux/errno.h>
 #include <linux/io.h>
 #include <linux/sizes.h>
diff --git a/arch/arm/mach-uniphier/dram_init.c b/arch/arm/mach-uniphier/dram_init.c
index 1127373b20..7f2753190c 100644
--- a/arch/arm/mach-uniphier/dram_init.c
+++ b/arch/arm/mach-uniphier/dram_init.c
@@ -5,7 +5,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <init.h>
 #include <linux/errno.h>
 #include <linux/io.h>
@@ -13,6 +12,7 @@
 #include <linux/printk.h>
 #include <linux/sizes.h>
 #include <asm/global_data.h>
+#include <asm/u-boot.h>
 
 #include "init.h"
 #include "sg-regs.h"
diff --git a/arch/arm/mach-uniphier/fdt-fixup.c b/arch/arm/mach-uniphier/fdt-fixup.c
index 6f3c29d8c0..980c260f4c 100644
--- a/arch/arm/mach-uniphier/fdt-fixup.c
+++ b/arch/arm/mach-uniphier/fdt-fixup.c
@@ -4,11 +4,11 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <fdt_support.h>
 #include <fdtdec.h>
 #include <jffs2/load_kernel.h>
 #include <mtd_node.h>
+#include <linux/errno.h>
 #include <linux/kernel.h>
 #include <linux/printk.h>
 
diff --git a/arch/arm/mach-uniphier/memconf.c b/arch/arm/mach-uniphier/memconf.c
index f69b489b76..57192f0154 100644
--- a/arch/arm/mach-uniphier/memconf.c
+++ b/arch/arm/mach-uniphier/memconf.c
@@ -5,7 +5,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <linux/errno.h>
 #include <linux/io.h>
 #include <linux/sizes.h>
diff --git a/arch/arm/mach-uniphier/micro-support-card.c b/arch/arm/mach-uniphier/micro-support-card.c
index 84c377766a..3bd26f26db 100644
--- a/arch/arm/mach-uniphier/micro-support-card.c
+++ b/arch/arm/mach-uniphier/micro-support-card.c
@@ -5,12 +5,13 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
+#include <config.h>
 #include <dm/of.h>
 #include <fdt_support.h>
 #include <linux/ctype.h>
 #include <linux/delay.h>
 #include <linux/io.h>
+#include <asm/global_data.h>
 
 #include "micro-support-card.h"
 
diff --git a/arch/arm/mach-uniphier/mmc-boot-mode.c b/arch/arm/mach-uniphier/mmc-boot-mode.c
index b48495365c..e47e5df648 100644
--- a/arch/arm/mach-uniphier/mmc-boot-mode.c
+++ b/arch/arm/mach-uniphier/mmc-boot-mode.c
@@ -4,7 +4,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <mmc.h>
 #include <spl.h>
 
diff --git a/arch/arm/mach-uniphier/mmc-first-dev.c b/arch/arm/mach-uniphier/mmc-first-dev.c
index 7f29b6bccd..45bb10f8eb 100644
--- a/arch/arm/mach-uniphier/mmc-first-dev.c
+++ b/arch/arm/mach-uniphier/mmc-first-dev.c
@@ -4,7 +4,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <command.h>
 #include <env.h>
 #include <mmc.h>
diff --git a/arch/arm/mach-uniphier/pinctrl-glue.c b/arch/arm/mach-uniphier/pinctrl-glue.c
index b45f72f59a..2e07264695 100644
--- a/arch/arm/mach-uniphier/pinctrl-glue.c
+++ b/arch/arm/mach-uniphier/pinctrl-glue.c
@@ -4,7 +4,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <linux/errno.h>
 #include <dm.h>
 #include <dm/pinctrl.h>
diff --git a/arch/arm/mach-uniphier/reset.c b/arch/arm/mach-uniphier/reset.c
index 92a8b92547..5fffd23e9a 100644
--- a/arch/arm/mach-uniphier/reset.c
+++ b/arch/arm/mach-uniphier/reset.c
@@ -5,7 +5,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <cpu_func.h>
 #include <linux/io.h>
 #include <asm/secure.h>
diff --git a/arch/arm/mach-uniphier/sbc/sbc-ld11.c b/arch/arm/mach-uniphier/sbc/sbc-ld11.c
index 21972ac949..a0162e1cc8 100644
--- a/arch/arm/mach-uniphier/sbc/sbc-ld11.c
+++ b/arch/arm/mach-uniphier/sbc/sbc-ld11.c
@@ -3,7 +3,6 @@
  * Copyright (C) 2016-2017 Socionext Inc.
  */
 
-#include <common.h>
 #include <spl.h>
 #include <linux/io.h>
 
diff --git a/arch/arm/mach-uniphier/sbc/sbc.c b/arch/arm/mach-uniphier/sbc/sbc.c
index af8d6f4f9d..2100f49a08 100644
--- a/arch/arm/mach-uniphier/sbc/sbc.c
+++ b/arch/arm/mach-uniphier/sbc/sbc.c
@@ -5,7 +5,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <linux/io.h>
 #include <asm/global_data.h>
 
diff --git a/arch/arm/mach-uniphier/spl_board_init.c b/arch/arm/mach-uniphier/spl_board_init.c
index 48764a1870..a93b8cdc04 100644
--- a/arch/arm/mach-uniphier/spl_board_init.c
+++ b/arch/arm/mach-uniphier/spl_board_init.c
@@ -4,7 +4,6 @@
  *   Author: Masahiro Yamada <yamada.masahiro at socionext.com>
  */
 
-#include <common.h>
 #include <debug_uart.h>
 #include <hang.h>
 #include <spl.h>