diff --git a/arch/arm/mach-imx/mxs/Kconfig b/arch/arm/mach-imx/mxs/Kconfig
index b90d7b6e4176..fb632b7df24f 100644
--- a/arch/arm/mach-imx/mxs/Kconfig
+++ b/arch/arm/mach-imx/mxs/Kconfig
@@ -12,10 +12,6 @@ config TARGET_MX23_OLINUXINO
 	bool "Support mx23_olinuxino"
 	select BOARD_EARLY_INIT_F
 
-config TARGET_MX23EVK
-	bool "Support mx23evk"
-	select BOARD_EARLY_INIT_F
-
 config TARGET_SANSA_FUZE_PLUS
 	bool "Support sansa_fuze_plus"
 
diff --git a/board/freescale/mx23evk/Kconfig b/board/freescale/mx23evk/Kconfig
deleted file mode 100644
index 51a8f9f773cb..000000000000
--- a/board/freescale/mx23evk/Kconfig
+++ /dev/null
@@ -1,15 +0,0 @@
-if TARGET_MX23EVK
-
-config SYS_BOARD
-	default "mx23evk"
-
-config SYS_VENDOR
-	default "freescale"
-
-config SYS_SOC
-	default "mxs"
-
-config SYS_CONFIG_NAME
-	default "mx23evk"
-
-endif
diff --git a/board/freescale/mx23evk/MAINTAINERS b/board/freescale/mx23evk/MAINTAINERS
deleted file mode 100644
index b03ad6ae0af6..000000000000
--- a/board/freescale/mx23evk/MAINTAINERS
+++ /dev/null
@@ -1,6 +0,0 @@
-MX23EVK BOARD
-M:	Otavio Salvador <otavio at ossystems.com.br>
-S:	Maintained
-F:	board/freescale/mx23evk/
-F:	include/configs/mx23evk.h
-F:	configs/mx23evk_defconfig
diff --git a/board/freescale/mx23evk/Makefile b/board/freescale/mx23evk/Makefile
deleted file mode 100644
index 6fe6992a5fcd..000000000000
--- a/board/freescale/mx23evk/Makefile
+++ /dev/null
@@ -1,10 +0,0 @@
-# SPDX-License-Identifier: GPL-2.0+
-#
-# (C) Copyright 2000-2006
-# Wolfgang Denk, DENX Software Engineering, wd at denx.de.
-
-ifndef	CONFIG_SPL_BUILD
-obj-y	:= mx23evk.o
-else
-obj-y	:= spl_boot.o
-endif
diff --git a/board/freescale/mx23evk/mx23evk.c b/board/freescale/mx23evk/mx23evk.c
deleted file mode 100644
index 6cfff0496631..000000000000
--- a/board/freescale/mx23evk/mx23evk.c
+++ /dev/null
@@ -1,78 +0,0 @@
-// SPDX-License-Identifier: GPL-2.0+
-/*
- * Freescale MX23EVK board
- *
- * (C) Copyright 2013 O.S. Systems Software LTDA.
- *
- * Author: Otavio Salvador <otavio at ossystems.com.br>
- *
- * Based on m28evk.c:
- * Copyright (C) 2011 Marek Vasut <marek.vasut at gmail.com>
- * on behalf of DENX Software Engineering GmbH
- */
-
-#include <common.h>
-#include <init.h>
-#include <asm/gpio.h>
-#include <asm/arch/imx-regs.h>
-#include <asm/arch/clock.h>
-#include <asm/arch/iomux-mx23.h>
-#include <asm/arch/sys_proto.h>
-
-DECLARE_GLOBAL_DATA_PTR;
-
-/*
- * Functions
- */
-int board_early_init_f(void)
-{
-	/* IO0 clock at 480MHz */
-	mxs_set_ioclk(MXC_IOCLK0, 480000);
-
-	/* SSP0 clock at 96MHz */
-	mxs_set_sspclk(MXC_SSPCLK0, 96000, 0);
-
-	/* Power on LCD */
-	gpio_direction_output(MX23_PAD_LCD_RESET__GPIO_1_18, 1);
-
-	/* Set contrast to maximum */
-	gpio_direction_output(MX23_PAD_PWM2__GPIO_1_28, 1);
-
-	return 0;
-}
-
-int dram_init(void)
-{
-	return mxs_dram_init();
-}
-
-int board_init(void)
-{
-	/* Adress of boot parameters */
-	gd->bd->bi_boot_params = PHYS_SDRAM_1 + 0x100;
-
-	return 0;
-}
-
-#ifdef	CONFIG_CMD_MMC
-static int mx23evk_mmc_wp(int id)
-{
-	if (id != 0) {
-		printf("MXS MMC: Invalid card selected (card id = %d)\n", id);
-		return 1;
-	}
-
-	return gpio_get_value(MX23_PAD_PWM4__GPIO_1_30);
-}
-
-int board_mmc_init(bd_t *bis)
-{
-	/* Configure WP as input */
-	gpio_direction_input(MX23_PAD_PWM4__GPIO_1_30);
-
-	/* Configure MMC0 Power Enable */
-	gpio_direction_output(MX23_PAD_PWM3__GPIO_1_29, 0);
-
-	return mxsmmc_initialize(bis, 0, mx23evk_mmc_wp, NULL);
-}
-#endif
diff --git a/board/freescale/mx23evk/spl_boot.c b/board/freescale/mx23evk/spl_boot.c
deleted file mode 100644
index 14e9b4a8634f..000000000000
--- a/board/freescale/mx23evk/spl_boot.c
+++ /dev/null
@@ -1,134 +0,0 @@
-// SPDX-License-Identifier: GPL-2.0+
-/*
- * Freescale MX23EVK Boot setup
- *
- * Copyright (C) 2011 Marek Vasut <marek.vasut at gmail.com>
- * on behalf of DENX Software Engineering GmbH
- */
-
-#include <common.h>
-#include <config.h>
-#include <asm/io.h>
-#include <asm/arch/iomux-mx23.h>
-#include <asm/arch/imx-regs.h>
-#include <asm/arch/sys_proto.h>
-
-#define	MUX_CONFIG_SSP1	(MXS_PAD_8MA | MXS_PAD_PULLUP)
-#define	MUX_CONFIG_EMI	(MXS_PAD_3V3 | MXS_PAD_12MA | MXS_PAD_PULLUP)
-#define	MUX_CONFIG_LCD	(MXS_PAD_4MA | MXS_PAD_NOPULL)
-
-const iomux_cfg_t iomux_setup[] = {
-	/* DUART */
-	MX23_PAD_PWM0__DUART_RX,
-	MX23_PAD_PWM1__DUART_TX,
-
-	/* EMI */
-	MX23_PAD_EMI_D00__EMI_D00 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_D01__EMI_D01 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_D02__EMI_D02 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_D03__EMI_D03 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_D04__EMI_D04 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_D05__EMI_D05 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_D06__EMI_D06 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_D07__EMI_D07 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_D08__EMI_D08 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_D09__EMI_D09 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_D10__EMI_D10 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_D11__EMI_D11 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_D12__EMI_D12 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_D13__EMI_D13 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_D14__EMI_D14 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_D15__EMI_D15 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_DQM0__EMI_DQM0 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_DQM1__EMI_DQM1 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_DQS0__EMI_DQS0 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_DQS1__EMI_DQS1 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_CLK__EMI_CLK | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_CLKN__EMI_CLKN | MUX_CONFIG_EMI,
-
-	MX23_PAD_EMI_A00__EMI_A00 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_A01__EMI_A01 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_A02__EMI_A02 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_A03__EMI_A03 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_A04__EMI_A04 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_A05__EMI_A05 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_A06__EMI_A06 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_A07__EMI_A07 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_A08__EMI_A08 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_A09__EMI_A09 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_A10__EMI_A10 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_A11__EMI_A11 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_A12__EMI_A12 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_BA0__EMI_BA0 | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_BA1__EMI_BA1 | MUX_CONFIG_EMI,
-
-	MX23_PAD_EMI_CASN__EMI_CASN | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_CE0N__EMI_CE0N | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_CE1N__EMI_CE1N | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_CKE__EMI_CKE | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_RASN__EMI_RASN | MUX_CONFIG_EMI,
-	MX23_PAD_EMI_WEN__EMI_WEN | MUX_CONFIG_EMI,
-
-	/* MMC 0 */
-	MX23_PAD_SSP1_DATA0__SSP1_DATA0 | MUX_CONFIG_SSP1,
-	MX23_PAD_SSP1_DATA1__SSP1_DATA1 | MUX_CONFIG_SSP1,
-	MX23_PAD_SSP1_DATA2__SSP1_DATA2 | MUX_CONFIG_SSP1,
-	MX23_PAD_SSP1_DATA3__SSP1_DATA3 | MUX_CONFIG_SSP1,
-	MX23_PAD_SSP1_CMD__SSP1_CMD | MUX_CONFIG_SSP1,
-	MX23_PAD_SSP1_DETECT__SSP1_DETECT | MUX_CONFIG_SSP1,
-		(MXS_PAD_8MA | MXS_PAD_3V3 | MXS_PAD_NOPULL),
-	MX23_PAD_SSP1_SCK__SSP1_SCK |
-		(MXS_PAD_8MA | MXS_PAD_3V3 | MXS_PAD_NOPULL),
-	/* Write Protect Pin */
-	MX23_PAD_PWM4__GPIO_1_30 |
-		(MXS_PAD_4MA | MXS_PAD_3V3 | MXS_PAD_NOPULL),
-	/* Slot Power Enable */
-	MX23_PAD_PWM3__GPIO_1_29 |
-		(MXS_PAD_4MA | MXS_PAD_3V3 | MXS_PAD_NOPULL),
-	/* LCD */
-	MX23_PAD_LCD_D00__LCD_D00 | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_D01__LCD_D01 | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_D02__LCD_D02 | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_D03__LCD_D03 | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_D04__LCD_D04 | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_D05__LCD_D05 | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_D06__LCD_D06 | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_D07__LCD_D07 | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_D08__LCD_D08 | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_D09__LCD_D09 | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_D10__LCD_D10 | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_D11__LCD_D11 | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_D12__LCD_D12 | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_D13__LCD_D13 | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_D14__LCD_D14 | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_D15__LCD_D15 | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_D16__LCD_D16 | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_D17__LCD_D17 | MUX_CONFIG_LCD,
-	MX23_PAD_GPMI_D08__LCD_D18 | MUX_CONFIG_LCD,
-	MX23_PAD_GPMI_D09__LCD_D19 | MUX_CONFIG_LCD,
-	MX23_PAD_GPMI_D10__LCD_D20 | MUX_CONFIG_LCD,
-	MX23_PAD_GPMI_D11__LCD_D21 | MUX_CONFIG_LCD,
-	MX23_PAD_GPMI_D12__LCD_D22 | MUX_CONFIG_LCD,
-	MX23_PAD_GPMI_D13__LCD_D23 | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_DOTCK__LCD_DOTCK | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_ENABLE__LCD_ENABLE | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_HSYNC__LCD_HSYNC | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_VSYNC__LCD_VSYNC | MUX_CONFIG_LCD,
-	MX23_PAD_LCD_RESET__GPIO_1_18 | MUX_CONFIG_LCD, /* LCD power */
-	MX23_PAD_PWM2__GPIO_1_28 | MUX_CONFIG_LCD, /* LCD contrast */
-};
-
-#define HW_DRAM_CTL14	(0x38 >> 2)
-#define CS_MAP		0x3
-#define INTAREF		0x2
-#define HW_DRAM_CTL14_CONFIG	(INTAREF << 8 | CS_MAP)
-
-void mxs_adjust_memory_params(uint32_t *dram_vals)
-{
-	dram_vals[HW_DRAM_CTL14] = HW_DRAM_CTL14_CONFIG;
-}
-
-void board_init_ll(const uint32_t arg, const uint32_t *resptr)
-{
-	mxs_common_spl_init(arg, resptr, iomux_setup, ARRAY_SIZE(iomux_setup));
-}
diff --git a/configs/mx23evk_defconfig b/configs/mx23evk_defconfig
deleted file mode 100644
index 7ff66686e8fd..000000000000
--- a/configs/mx23evk_defconfig
+++ /dev/null
@@ -1,40 +0,0 @@
-CONFIG_ARM=y
-CONFIG_ARCH_MX23=y
-CONFIG_SYS_TEXT_BASE=0x40002000
-CONFIG_SPL_GPIO_SUPPORT=y
-CONFIG_SPL_LIBCOMMON_SUPPORT=y
-CONFIG_SPL_LIBGENERIC_SUPPORT=y
-CONFIG_ENV_SIZE=0x4000
-CONFIG_ENV_OFFSET=0x40000
-CONFIG_TARGET_MX23EVK=y
-CONFIG_SPL_SERIAL_SUPPORT=y
-CONFIG_NR_DRAM_BANKS=1
-CONFIG_SPL=y
-CONFIG_SPL_TEXT_BASE=0x00001000
-# CONFIG_CONSOLE_MUX is not set
-CONFIG_SYS_CONSOLE_IS_IN_ENV=y
-CONFIG_VERSION_VARIABLE=y
-# CONFIG_DISPLAY_BOARDINFO is not set
-CONFIG_ARCH_MISC_INIT=y
-# CONFIG_SPL_FRAMEWORK is not set
-CONFIG_HUSH_PARSER=y
-CONFIG_CMD_BOOTZ=y
-CONFIG_CMD_GPIO=y
-CONFIG_CMD_MMC=y
-CONFIG_CMD_USB=y
-# CONFIG_CMD_SETEXPR is not set
-CONFIG_CMD_BMP=y
-CONFIG_CMD_CACHE=y
-CONFIG_CMD_EXT2=y
-CONFIG_CMD_FAT=y
-CONFIG_ENV_IS_IN_MMC=y
-CONFIG_SYS_RELOC_GD_ENV_ADDR=y
-# CONFIG_NET is not set
-CONFIG_MXS_GPIO=y
-CONFIG_MMC_MXS=y
-CONFIG_CONS_INDEX=0
-CONFIG_USB=y
-CONFIG_USB_EHCI_HCD=y
-CONFIG_USB_STORAGE=y
-CONFIG_VIDEO=y
-CONFIG_OF_LIBFDT=y
diff --git a/include/configs/mx23evk.h b/include/configs/mx23evk.h
deleted file mode 100644
index 595727aa3071..000000000000
--- a/include/configs/mx23evk.h
+++ /dev/null
@@ -1,110 +0,0 @@
-/* SPDX-License-Identifier: GPL-2.0+ */
-/*
- * Freescale i.MX23 EVK board config
- *
- * Copyright (C) 2013 Otavio Salvador <otavio at ossystems.com.br>
- * on behalf of O.S. Systems Software LTDA.
- */
-#ifndef __CONFIGS_MX23EVK_H__
-#define __CONFIGS_MX23EVK_H__
-
-/* System configurations */
-#define CONFIG_MACH_TYPE	MACH_TYPE_MX23EVK
-
-/* U-Boot Commands */
-
-/* Memory configuration */
-#define PHYS_SDRAM_1			0x40000000	/* Base address */
-#define PHYS_SDRAM_1_SIZE		0x08000000	/* Max 128 MB RAM */
-#define CONFIG_SYS_SDRAM_BASE		PHYS_SDRAM_1
-
-/* Environment */
-#define CONFIG_ENV_OVERWRITE
-
-/* Environment is in MMC */
-#if defined(CONFIG_CMD_MMC) && defined(CONFIG_ENV_IS_IN_MMC)
-#define CONFIG_SYS_MMC_ENV_DEV	0
-#endif
-
-/* USB */
-#ifdef	CONFIG_CMD_USB
-#define CONFIG_EHCI_MXS_PORT0
-#define CONFIG_USB_MAX_CONTROLLER_COUNT 1
-#endif
-
-/* Framebuffer support */
-#ifdef CONFIG_VIDEO
-#define CONFIG_VIDEO_LOGO
-#define CONFIG_SPLASH_SCREEN
-#define CONFIG_BMP_16BPP
-#define CONFIG_VIDEO_BMP_RLE8
-#define CONFIG_VIDEO_BMP_GZIP
-#define CONFIG_SYS_VIDEO_LOGO_MAX_SIZE	(512 << 10)
-#endif
-
-/* Boot Linux */
-#define CONFIG_BOOTFILE		"uImage"
-#define CONFIG_LOADADDR		0x42000000
-#define CONFIG_SYS_LOAD_ADDR	CONFIG_LOADADDR
-
-/* Extra Environments */
-#define CONFIG_EXTRA_ENV_SETTINGS \
-	"update_sd_firmware_filename=u-boot.sd\0" \
-	"update_sd_firmware="		/* Update the SD firmware partition */ \
-		"if mmc rescan ; then "	\
-		"if tftp ${update_sd_firmware_filename} ; then " \
-		"setexpr fw_sz ${filesize} / 0x200 ; "	/* SD block size */ \
-		"setexpr fw_sz ${fw_sz} + 1 ; "	\
-		"mmc write ${loadaddr} 0x800 ${fw_sz} ; " \
-		"fi ; "	\
-		"fi\0" \
-	"script=boot.scr\0"	\
-	"image=zImage\0" \
-	"console=ttyAMA0\0" \
-	"fdt_file=imx23-evk.dtb\0" \
-	"fdt_addr=0x41000000\0" \
-	"boot_fdt=try\0" \
-	"mmcdev=0\0" \
-	"mmcpart=2\0" \
-	"mmcroot=/dev/mmcblk0p3 rw rootwait\0" \
-	"mmcargs=setenv bootargs console=${console},${baudrate} " \
-		"root=${mmcroot}\0" \
-	"loadbootscript="  \
-		"fatload mmc ${mmcdev}:${mmcpart} ${loadaddr} ${script};\0" \
-	"bootscript=echo Running bootscript from mmc ...; "	\
-		"source\0" \
-	"loadimage=fatload mmc ${mmcdev}:${mmcpart} ${loadaddr} ${image}\0" \
-	"loadfdt=fatload mmc ${mmcdev}:${mmcpart} ${fdt_addr} ${fdt_file}\0" \
-	"mmcboot=echo Booting from mmc ...; " \
-		"run mmcargs; " \
-		"if test ${boot_fdt} = yes || test ${boot_fdt} = try; then " \
-			"if run loadfdt; then " \
-				"bootz ${loadaddr} - ${fdt_addr}; " \
-			"else " \
-				"if test ${boot_fdt} = try; then " \
-					"bootz; " \
-				"else " \
-					"echo WARN: Cannot load the DT; " \
-				"fi; " \
-			"fi; " \
-		"else " \
-			"bootz; " \
-		"fi;\0"
-
-#define CONFIG_BOOTCOMMAND \
-	"mmc dev ${mmcdev}; if mmc rescan; then " \
-		"if run loadbootscript; then " \
-			"run bootscript; " \
-		"else " \
-			"if run loadimage; then " \
-				"run mmcboot; " \
-			"else " \
-				"echo ERR: Fail to boot from MMC; " \
-			"fi; " \
-		"fi; " \
-	"else exit; fi"
-
-/* The rest of the configuration is shared */
-#include <configs/mxs.h>
-
-#endif /* __CONFIGS_MX23EVK_H__ */